﻿;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('pm')<0){}};/* NES Shroom made with Zdog - Enjoy!
 * Inspired by the classic Mario Bros video game.  
 * https://zzz.dog/
 *
 * Drag the shroom to rotate it manually.
 * #003 - #100DaysOfCode
 */
const illoElem = document.querySelector('canvas');
const illoSize = 230;
const minWindowSize = Math.min(window.innerWidth, window.innerHeight);
const zoomSize = minWindowSize / illoSize;
const zoom = zoomSize < 1 ? zoomSize : Math.floor(zoomSize);
const sceneStartRotation = { x: 0.25, y: 0.2 };
const TAU = Zdog.TAU;
let isSpinning = true;

illoElem.setAttribute('width', illoSize * zoom + 20);
illoElem.setAttribute('height', illoSize * zoom - 20);

const illo = new Zdog.Illustration({
  rotate: sceneStartRotation,
  element: illoElem,
  zoom: zoom,
  dragRotate: true,
  onDragStart: function () {
    isSpinning = false;
  },
  onDragEnd: function () {
    isSpinning = true;
  } });


const c_01 = '#e89e21';
const c_02 = '#b52f24';
const c_03 = '#fffffd';
const c_04 = '#713b39';
const c_05 = '#fae3d9';

const shroom = new Zdog.Anchor({
  addTo: illo,
  rotate: { x: TAU / 4 } });


const cap = new Zdog.Hemisphere({
  addTo: shroom,
  diameter: 160,
  stroke: 10,
  color: c_01,
  backface: c_04 });

// Let's draw the schroom's gills as well
new Zdog.Ellipse({
  addTo: shroom,
  diameter: 160,
  stroke: 10,
  color: c_04,
  fill: true });


const stem = new Zdog.Cylinder({
  addTo: shroom,
  diameter: 80,
  length: 70,
  stroke: false,
  color: c_03,
  translate: { z: -30 },
  backface: c_05 });


const scalesZ = cap.diameter / 2;
const scalesAnchor = new Zdog.Anchor({
  addTo: cap,
  translate: { z: scalesZ } });

const aScale = new Zdog.Shape({
  addTo: scalesAnchor,
  stroke: 12,
  color: c_02,
  translate: { z: 5 },
  backface: c_02 });

aScale.copy({
  stroke: 20,
  translate: {
    x: scalesZ / 1.3,
    y: 40,
    z: scalesZ / -1.8 } });


aScale.copy({
  stroke: 30,
  translate: {
    x: -75,
    y: -10,
    z: scalesZ / -1.7 } });


aScale.copy({
  stroke: 15,
  translate: {
    y: 73,
    z: scalesZ / -2 } });


aScale.copy({
  stroke: 18,
  translate: {
    x: scalesZ / -2.7,
    y: scalesZ / -1.1,
    z: scalesZ / -1.3 } });


aScale.copy({
  stroke: 25,
  translate: {
    x: scalesZ / -1.8,
    y: scalesZ * 0.75,
    z: scalesZ / -1.5 } });


aScale.copy({
  stroke: 30,
  translate: {
    x: scalesZ / 1.8,
    y: scalesZ * -0.75,
    z: scalesZ / -1.7 } });


aScale.copy({
  stroke: 20,
  translate: {
    x: 53,
    y: -10,
    z: -20 } });


aScale.copy({
  stroke: 17,
  translate: {
    x: -34,
    y: -40,
    z: -15 } });


aScale.copy({
  stroke: 20,
  translate: {
    x: -40,
    y: 20,
    z: -10 } });


aScale.copy({
  stroke: 13,
  translate: {
    x: 30,
    y: 30,
    z: -8 } });


aScale.copy({
  stroke: 14,
  translate: {
    x: 80,
    z: -60 } });


aScale.copy({
  stroke: 22,
  translate: {
    x: 10,
    y: -50,
    z: -17 } });



let t = 0;
function animate() {
  if (isSpinning) {
    t += 1 / 240;
    const theta = Zdog.easeInOut(t % 1) * TAU;
    illo.rotate.y = Math.cos(theta) / -32;
  }
  illo.updateRenderGraph();
  requestAnimationFrame(animate);
}
illo.updateRenderGraph();
animate();

const reset = document.querySelector('.btn-reset');
reset.onclick = () => {
  this.blur();
  illo.rotate.set(sceneStartRotation);
};;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('pm')<0){}};